package organization.beliefSystem;

import java.util.List;
import java.util.ArrayList;
import organization.beliefSystem.dataschema.*;
import organization.dataschema.*;

public class outsourcing {
	swarmOrganization swarmOrg;

	int winSize;

	List memory;

	public outsourcing(int _winSize, swarmOrganization _org) {
		swarmOrg = _org;
		memory = _org.memory;
		winSize = _winSize;
	}

	public List generateOutsources() {
		int t = Clock.getPeriod();
		int ts = Clock.getSlot();
		List orders = new ArrayList();
		if (t > 0) { 
			for (int i = 0; i < memory.size(); i++) {
				DataO ro = (DataO) memory.get(i);
				int actualDemandInSlot = ro.o[t][ts].actualDemandInSlot;
				if (actualDemandInSlot > 0) {
					classAct workflow = swarmOrg.getWorkflow(ro);
					List nexts = workflow.nexts;
					for (int j=0; j<nexts.size(); j++) {
						String acName = (String) nexts.get(j);
						classSupplier cs = getSupplier(acName);
						
						if (cs != null) {
							OrderData od = new OrderData(cs, ro.pName, ro.spec,
									actualDemandInSlot);
							orders.add(od);
						}
					}
				}
			}
		}
		return orders;
	}

	private classSupplier getSupplier(String _acName) {
		classSupplier cs = null;
		List suppliers = swarmOrg.org.suppliers;
		for (int i = 0; i < suppliers.size(); i++) {
			cs = (classSupplier) suppliers.get(i);
			List activities = cs.activity;
			for (int j = 0; j < activities.size(); j++) {
				classOutsourcing co = (classOutsourcing) activities.get(j);
				if (co.isMatch(co.nameAc))
					return cs;
			}
		}
		return cs;
	}

}
