package organization.operation.process;

import java.util.List;

import organization.dataschema.*;
import organization.operation.OperationHub;
import organization.operation.Department;

public class ProcessManager extends Department {

	private ProcessManagement process;

	private MakeOrBuyManagement mob;

	public ProcessManager(OperationHub _ipi) {
		super(_ipi);
		this.process = new ProcessManagement(this);
		this.mob = new MakeOrBuyManagement(this);
	}

	public void updateManagementLogic(Object _obj) {
		if (_obj instanceof ProcessManagement)
			this.process = (ProcessManagement) _obj;
		else if (_obj instanceof MakeOrBuyManagement)
			this.mob = (MakeOrBuyManagement) _obj;
	}

	public classProject getOFP(Object _obj, int _op_OFP) {
		return null;
	}

	public classProject getSimulatedOFP(Object _obj) {
		List possibleProcesses = this.getPossibleProcess(_obj);
		classProject cp = this.ohub.getSimulatedOFP(possibleProcesses);
		cp = this.getWorkflow(cp);
		cp = this.mob.getPotentialFulfillmentMethod(cp);
		cp = this.ohub.determineMakeorBuyBySimulation(cp);
		return cp;
	}

	public List getPossibleProcess(Object _obj) {
		return this.process.getPossibleProcess(_obj);
	}

	public classProject getWorkflow(classProject _cp) {
//codes are removed, reserved for future use 		
		return _cp;
	}

	public classProject getPotentialFulfillmentMethod(classProject _cp) {
		return this.mob.getPotentialFulfillmentMethod(_cp);
	}
}
